<?php

/* * *************************************************************
*  Copyright notice
*
*  (c) 2011-2012 - Daniel Lorenz <daniel.lorenz@capsicum-ug.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
* ************************************************************* */

require_once(PATH_tslib . 'class.tslib_pibase.php');

/**
* Plugin 'Cart' for the 'wt_cart' extension.
*
* @author	Daniel Lorenz <daniel.lorenz@capsicum-ug.de>
* @package	TYPO3
* @subpackage	tx_wtcart
* @version	1.4.0
*/
class tx_wtcart_render extends tslib_pibase {
	public $prefixId = 'tx_wtcart_pi1';
	public $scriptRelPath = 'pi1/class.tx_wtcart_pi1.php';
	public $extKey = 'wt_cart';
	
	
	public function renderOptionById($conf, $type, $option_id, &$obj) {
		$optionIds = $conf[$type.'.']['options.'][$option_id.'.'];
		
		$filterArr = array(
			'by_price' => $obj->cartGrossNoService,
			'by_quantity' => $obj->cartCount,
			'by_service_attribute_1_sum' => $obj->cartServiceAttribute1Sum,
			'by_service_attribute_1_max' => $obj->cartServiceAttribute1Max,
			'by_service_attribute_2_sum' => $obj->cartServiceAttribute2Sum,
			'by_service_attribute_2_max' => $obj->cartServiceAttribute2Max,
			'by_service_attribute_3_sum' => $obj->cartServiceAttribute3Sum,
			'by_service_attribute_3_max' => $obj->cartServiceAttribute3Max
		);
		
		$option = '';
		
		if (array_key_exists($optionIds['extra'], $filterArr)) {
			foreach ($optionIds['extra.'] as $extra) {
				if (floatval($extra['value']) <= $filterArr[$optionIds['extra']]) {
					$option = $this->renderOption($conf, $type, $option_id, floatval($extra['extra']), $obj);
				} else {
					if ($option == '') {
						return $conf[$type.'.']['options.'][$option_id . '.']['title'] . ' (0,00 ' . $conf['main.']['currencySymbol'] . ') <br />';
					}
					break;
				}
			}
		} else {
			switch ($optionIds['extra']) {
				case 'each':
					$gross = floatval($optionIds['extra.']['1.']['extra'])*$obj->cartCount;
					$option = $this->renderOption($conf, $type, $option_id, $gross, $obj);
					break;
				default:
					$option = $conf[$type.'.']['options.'][$option_id . '.']['title'] . ' (' . str_replace('.', ',', $conf[$type.'.']['options.'][$option_id . '.']['extra']) . ' ' . $conf['main.']['currencySymbol'] . ') <br />';
			}
		}
		
		return $option;
	}
	
	public function renderOption($conf, $type, $option_id, $gross, $obj) {
		$free_from = $conf[$type.'.']['options.'][$option_id . '.']['free_from'];
		$free_until = $conf[$type.'.']['options.'][$option_id . '.']['free_until'];
		if ((isset($free_from) && (floatval($free_from) <= $obj->cartGrossNoService)) || (isset($free_until) && (floatval($free_until) >= $obj->cartGrossNoService))) {
			return $conf[$type.'.']['options.'][$option_id . '.']['title'] . ' (0,00 ' . $conf['main.']['currencySymbol'] . ') <br />';
		}
		
	 	return $conf[$type.'.']['options.'][$option_id . '.']['title'] . ' (' . number_format($gross, 2, ',', '.') . ' ' . $conf['main.']['currencySymbol'] . ') <br />';
	}
}